/**
 * Header file for load simulation logic.
 */


// System Import Headers.
#include <ctype.h>
#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


// Function Prototypes.
void display_status();
void run_arr();             // Encapsulated logic for "Asynchronous Round Robin" load scheme.
void main_arr();
void worker_arr();
void run_grr();             // Encapsulated logic for "Global Round Robin" load scheme.
void run_rp();              // Encapsulated logic for "Random Poling" load scheme.
void run_nn();              // Encapsulated logic for "Nearest Neighbor" load scheme.
void simulate_load();       // Simulates running one load.
void* simulate_arr_load();  // Thread entrypoint for an "Asynchronous Round Robin" load.
void* simulate_grr_load();  // Thread entrypoint for a "Global Round Robin" load.
void* simulate_rp_load();   // Thread entrypoint for a "Random Polling" load.
void* simulate_nn_load();   // Thread entrypoint for a "Nearest Neigher" load.
